<template>
	<CardLayout>
		<template slot="head">
			<CommonHeader :showBackButton="true" :title="$t('menu')"></CommonHeader>
		</template>
		<template slot="top">
			<div class="top">
				<Background :custom="true">
					<VariableLogo class="logo" :custom="true"></VariableLogo>
				</Background>
			</div>
		</template>
		<template slot="body">
			<div class="home-body">
				<div class="card-title">
					<span>{{ $t('categories') }}</span>
					<div>
						<ActionList ref="seeall" :text="$t('seeAll')" @click="seeMoreCategories()"></ActionList>
					</div>
				</div>
				<div class="categories" :class="{ 'big-categories': products.length == 0 }">
					<div
						v-for="(category, index) in categories"
						class="category"
						:key="index"
						@click="seeCategory(category)"
					>
						<CategoryIcon
							:size="products.length == 0 ? '150px' : undefined"
							:src="category.iconURL"
							:name="localizedCategoryName(category)"
						></CategoryIcon>
						<span>{{ localizedCategoryName(category) }}</span>
					</div>
				</div>
				<div class="most-selled-section" v-if="products.length > 0">
					<div class="most-selled-title">{{ $t('mostRequested') }}</div>
					<div class="most-selled-body">
						<div
							v-for="(product, index) in products"
							class="product"
							:key="index"
							@click="seeProduct(product)"
						>
							<Thumbnail class="photo-thumbnail" :src="product.photosURL[0]"></Thumbnail>
							<div class="plaque">
								<div class="info">
									<span>{{ localizedProductName(product) }}</span>
									<br>
									<span class="description">{{ localizedProductDescription(product) }}</span>
									<span class="price">{{ formatPrice(localizedProductPrice(product), true) }}</span>
								</div>
								<div class="content-next">
									<Next class="next"></Next>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<MiniCart></MiniCart>
		</template>
	</CardLayout>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CardLayout from '@/layouts/CardLayout.vue'
import Background from '@/components/Background.vue'
import Next from '@/components/Next.vue'
import ActionList from '@/components/ActionList.vue'
import CategoryIcon from '@/components/CategoryIcon.vue'
import Thumbnail from '@/components/Thumbnail.vue'
import MiniCart from '@/components/MiniCart.vue'
import Category from '@/models/Category'
import Product from '@/models/Product'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import CommonHeader from '@/components/CommonHeader.vue'
import { localizedProductPrice } from '../mixins/MenuLocalization'
import VariableLogo from '@/components/VariableLogo.vue'
import Localization from '../models/Localization'
import { MainView } from '@/store/state'

@Component({
	components: {
		Background,
		VariableLogo,
		CardLayout,
		Next,
		ActionList,
		CategoryIcon,
		Thumbnail,
		SpinnerHolder,
		CommonHeader,
		MiniCart,
	},
})
export default class Menu extends Vue {
	categories: Array<Category> = []
	products: Array<Product> = []
	localizations: Array<Localization> = this.$store.state.menu ? this.$store.state.menu.localizations : []

	seeMoreCategories() {
		this.$router.push('/categories')
	}

	seeCategory(category: Category) {
		if (category.subcategories.length > 0) {
			this.$store.dispatch('setCategoryId', category.id)
			this.$router.push('/subcategories')
		} else {
			this.$router.push('/categories/' + category.id)
		}
	}

	seeProduct(product: Product) {
		this.$store.dispatch('setCategoryId', product.categoryId)
		this.$router.push('/products/' + product.id)
	}

	getMostSelledProducts(): Product[] {
		if (this.$store.getters.showMostSelled) {
			const products = this.$store.getters.products as Product[]
			return products
				.filter((p) => p.mostSelled && localizedProductPrice(p))
				.sort((c, n) => c.mostSelledPriority - n.mostSelledPriority)
		}
		return this.products
	}

	getHomeCategories(): Category[] {
		const categories = this.$store.getters.categories as Category[]
		return categories.filter((c) => c.showsAtHome).sort((c, n) => c.showsAtHomePriority - n.showsAtHomePriority)
	}

	async created() {	
		await this.$store.dispatch('setMainView', MainView.MENU)
		this.categories = this.getHomeCategories()
		this.products = this.getMostSelledProducts()
	}
}
</script>

<style lang="scss" scoped>
.top {
	height: 100%;
	width: 100%;
	color: #ffffff;
	display: flex;
	justify-content: center;
	align-items: center;
	// background-image: url('~@/assets/img/hojas.png');
	background-size: contain;
	background-position: bottom;
}

.top .logo {
	height: 100%;
	width: 50%;
	margin: 10px auto 20px auto;
	background-repeat: no-repeat;
	background-position: center;
	position: relative;
	display: flex;
	background-size: contain;
}

.home-body {
	display: flex;
	flex-direction: column;
	justify-content: space-around;
	.card-title {
		display: flex;
		justify-content: space-between;
		align-items: center;
		padding: 0.5em 1.04em;
		position: relative;
		span {
			font-weight: 700;
			font-size: 1.2em;
		}
		div {
			display: flex;
			justify-content: center;
			align-items: center;
			span {
				font-size: 1.2em;
				color: #feca38;
				position: absolute;
				bottom: 0px;
			}
		}
	}

	.categories {
		display: flex;
		justify-content: flex-start;
		overflow-x: auto;
		padding-right: 1.05em;
		// background: brown;
		.category {
			display: flex;
			flex-direction: column;
			align-items: center;
			color: #646979;
			margin: 0 1.05em 1em 1.05em;
			span {
				text-align: center;
				word-wrap: break-word;
				font-size: 0.9em;
				color: black;
				font-weight: bold;
				margin-top: 0.5em;
				width: 90px;
				overflow: hidden;
				white-space: nowrap;
				text-overflow: ellipsis;
			}
		}
	}

	.big-categories {
		overflow: hidden;
		flex-wrap: wrap;
		justify-content: space-around;
		.category {
			width: unset;
			margin: 10px;
		}
	}

	.most-selled-section {
		widows: 100%;

		.most-selled-title {
			font-weight: bold;
			padding: 0.7em;
			font-size: 1.1em;
		}

		.most-selled-body {
			width: 100%;
			padding-bottom: 3vh;

			.product {
				display: inline-flex;
				margin: 0.5em;
				padding: 0.5em;
				width: 90%;
				background: #ffffff;
				box-shadow: 0px 1px 4px rgba(0, 0, 0, 0.25);
				border-radius: 4px;

				.plaque {
					display: flex;
					width: 100%;
					flex-direction: row;
					justify-content: space-around;
					.info {
						font-weight: bold;
						margin-right: auto;
						font-size: 16px;
						line-height: 19px;
						margin-left: 10px;
						.description {
							font-weight: normal;
							color: #4f4f4f;
							font-size: 14px;
							line-height: 16px;
							overflow: hidden;
							display: -webkit-box;
							-webkit-line-clamp: 2;
							-webkit-box-orient: vertical;
						}
						.price {
							margin-top: 15px;
							font-size: 23px;
							font-weight: 800;
							color: #feca38;
							display: block;
						}
					}

					.seeProduct {
						width: 20px;
						height: 20px;
					}
				}
				.photo-thumbnail {
					width: 95.24px;
					height: 90.46px;
					border-radius: 10px;
				}
			}
		}
	}
}

.content-next {
	margin: auto 0 !important;
	.next {
		background-color: transparent !important;
	}
}

.animate {
	animation-name: scale;
	animation-duration: 1s;
	animation-iteration-count: 2;
}

@keyframes scale {
	0% {
		transform: scale(1, 1) translateY(0);
	}
	10% {
		transform: scale(1.1, 0.9) translateY(0);
	}
	30% {
		transform: scale(0.9, 1.1) translateY(-30px);
	}
	50% {
		transform: scale(1, 1) translateY(0);
	}
	57% {
		transform: scale(1, 1) translateY(-7px);
	}
	64% {
		transform: scale(1, 1) translateY(0);
	}
	100% {
		transform: scale(1, 1) translateY(0);
	}
}
</style>